"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.plugins = void 0;

var _identifier = require("../util/identifier");

var _options = require("../options");

var _tokenizer = _interopRequireDefault(require("../tokenizer"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var plugins = {};
exports.plugins = plugins;
var frozenDeprecatedWildcardPluginList = ["jsx", "doExpressions", "objectRestSpread", "decorators", "classProperties", "exportExtensions", "asyncGenerators", "functionBind", "functionSent", "dynamicImport", "flow"];

var Parser =
/*#__PURE__*/
function (_Tokenizer) {
  _inherits(Parser, _Tokenizer);

  function Parser(options, input) {
    var _this;

    _classCallCheck(this, Parser);

    options = (0, _options.getOptions)(options);
    _this = _possibleConstructorReturn(this, _getPrototypeOf(Parser).call(this, options, input));
    _this.options = options;
    _this.inModule = _this.options.sourceType === "module";
    _this.input = input;
    _this.plugins = _this.loadPlugins(_this.options.plugins);
    _this.filename = options.sourceFilename; // If enabled, skip leading hashbang line.

    if (_this.state.pos === 0 && _this.input[0] === "#" && _this.input[1] === "!") {
      _this.skipLineComment(2);
    }

    return _this;
  }

  _createClass(Parser, [{
    key: "isReservedWord",
    value: function isReservedWord(word) {
      if (word === "await") {
        return this.inModule;
      } else {
        return _identifier.reservedWords[6](word);
      }
    }
  }, {
    key: "hasPlugin",
    value: function hasPlugin(name) {
      if (this.plugins["*"] && frozenDeprecatedWildcardPluginList.indexOf(name) > -1) {
        return true;
      }

      return !!this.plugins[name];
    }
  }, {
    key: "extend",
    value: function extend(name, f) {
      this[name] = f(this[name]);
    }
  }, {
    key: "loadAllPlugins",
    value: function loadAllPlugins() {
      var _this2 = this;

      // ensure flow plugin loads last, also ensure estree is not loaded with *
      var pluginNames = Object.keys(plugins).filter(function (name) {
        return name !== "flow" && name !== "estree";
      });
      pluginNames.push("flow");
      pluginNames.forEach(function (name) {
        var plugin = plugins[name];
        if (plugin) plugin(_this2);
      });
    }
  }, {
    key: "loadPlugins",
    value: function loadPlugins(pluginList) {
      // TODO: Deprecate "*" option in next major version of Babylon
      if (pluginList.indexOf("*") >= 0) {
        this.loadAllPlugins();
        return {
          "*": true
        };
      }

      var pluginMap = {};

      if (pluginList.indexOf("flow") >= 0) {
        // ensure flow plugin loads last
        pluginList = pluginList.filter(function (plugin) {
          return plugin !== "flow";
        });
        pluginList.push("flow");
      }

      if (pluginList.indexOf("estree") >= 0) {
        // ensure estree plugin loads first
        pluginList = pluginList.filter(function (plugin) {
          return plugin !== "estree";
        });
        pluginList.unshift("estree");
      }

      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = pluginList[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var name = _step.value;

          if (!pluginMap[name]) {
            pluginMap[name] = true;
            var plugin = plugins[name];
            if (plugin) plugin(this);
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator["return"] != null) {
            _iterator["return"]();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      return pluginMap;
    }
  }, {
    key: "parse",
    value: function parse() {
      var file = this.startNode();
      var program = this.startNode();
      this.nextToken();
      return this.parseTopLevel(file, program);
    }
  }]);

  return Parser;
}(_tokenizer["default"]);

exports["default"] = Parser;